%define pref /usr
%define ver 2.5.3
%define ver2 2.5
%define rel 2

# Configurable settings (use --with(out) {unicode,gtk2} on rpmbuild cmd line):
%define unicode 0
%{?_with_unicode: %{expand: %%define unicode 1}}
%{?_without_unicode: %{expand: %%define unicode 0}}

%define gtkver   2
%define portname gtk2
%define portpkgname GTK%{gtkver}

%define name        wx%{portpkgname}
%define wxbasename  wxBase

Name:    %{name}
Summary: The GTK+ %{gtkver} port of the wxWidgets library
Version: %{ver}
Release: %{rel}
License: wxWidgets Licence
Group: X11/Libraries
Source: wxGTK-%{ver}.tar.bz2
Patch0: wxGTK-%{ver}-wxconfig.patch
URL: http://www.wxwidgets.org
Packager: Fritz Elfert <fritz.elfert@millenux.com>
Prefix: %{pref}
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: gcc-c++, gtk2-devel >= 2.4.7, zlib-devel
BuildRequires: libjpeg-devel, libpng-devel, libtiff-devel

# all packages providing an implementation of wxWindows library (regardless of
# the toolkit used) should provide the (virtual) wxwin package, this makes it
# possible to require wxwin instead of requiring "wxgtk or wxmotif or wxuniv..."
Provides: wxwin
Provides: wxGTK

# in addition, we should provide libwx_gtk as automatic generator only notices
# libwx_gtk-%{ver}-%{rel}
Provides: libwx_gtk.so
Provides: libwx_gtk-%{ver2}.so

Requires: %{wxbasename} = %{ver}

%description
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

%package devel
Summary: The GTK+ %{gtkver} port of the wxWidgets library
Group: X11/Libraries
Requires: %{name} = %{ver}
Requires: %{wxbasename}-devel = %{ver}
Provides: wxGTK-devel

%description devel
Header files for wxGTK, the GTK+ %{gtkver} port of the wxWidgets library.

%package gl
Summary: The GTK+ %{gtkver} port of the wxWidgets library, OpenGL add-on.
Group: X11/Libraries
Requires: %{name} = %{ver}

%description gl
OpenGL add-on library for wxGTK, the GTK+ %{gtkver} port of the wxWidgets library.

%package static
Summary: wxGTK static libraries
Group: Development/Libraries
Requires: %{wxbasename}-static

%description static
Static libraries for wxGTK. You need them if you want to link statically against wxGTK.

%package contrib
Summary: The GTK+ %{gtkver} port of the wxWidgets library, contributed libraries.
Group: X11/Libraries
Requires: %{name} = %{ver}

%description contrib
Contributed libraries for wxGTK, the GTK+ %{gtkver} port of the wxWidgets library.

%package contrib-devel
Summary: The GTK+ %{gtkver} port of the wxWidgets library
Group: X11/Libraries
Requires: %{name}-contrib = %{ver}
Requires: %{name}-devel = %{ver}

%description contrib-devel
Header files for contributed libraries for wxGTK, the GTK+ %{gtkver} port of the wxWidgets library.

%package -n %{wxbasename}
Summary: The base port of the wxWidgets library.
Group: Development/Libraries

%description -n %{wxbasename}
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

%package -n %{wxbasename}-static
Summary: Static libraries of the base wxWidgets port.
Group: Development/Libraries

%description -n %{wxbasename}-static
Static libraries of the base wxWidgets port.

%package -n %{wxbasename}-devel
Summary: The base port of the wxWidgets library.
Group: Development/Libraries

%description -n %{wxbasename}-devel
Header files for the base port of the wxWidgets library.

%prep
%setup -q -n wxGTK-%{ver}
%patch0 -p1

%build
if [ "$SMP" != "" ]; then
  export MAKE="make -j$SMP"
else
  export MAKE="make"
fi

#
# static ansi build
mkdir obj-static
pushd obj-static
ln -s ../configure .
%configure --disable-shared \
	--disable-compat24 \
	--with-odbc \
	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

mkdir obj-static-debug
pushd obj-static-debug
ln -s ../configure .
%configure --disable-shared \
	--disable-compat24 \
	--enable-debug \
	--enable-debug_gdb \
	--enable-debug_cntxt \
      	--with-odbc \
      	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

mkdir obj-shared
pushd obj-shared
ln -s ../configure .
%configure \
	--disable-compat24 \
	--with-odbc \
	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

mkdir obj-static-unicode
pushd obj-static-unicode
ln -s ../configure .
%configure --disable-shared \
	--disable-compat24 \
	--enable-unicode \
	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

mkdir obj-static-unicode-debug
pushd obj-static-unicode-debug
ln -s ../configure .
%configure --disable-shared \
	--disable-compat24 \
	--enable-debug \
	--enable-debug_gdb \
	--enable-debug_cntxt \
      	--enable-unicode \
      	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

mkdir obj-shared-unicode
pushd obj-shared-unicode
ln -s ../configure .
%configure \
	--disable-compat24 \
	--enable-unicode \
	--with-opengl
rm -f configure
$MAKE
cd contrib/src
$MAKE
popd

%install
rm -rf $RPM_BUILD_ROOT
pushd obj-static-unicode
%makeinstall
popd
pushd obj-static-unicode-debug
%makeinstall
popd
pushd obj-shared-unicode
%makeinstall
popd
pushd obj-static
%makeinstall
popd
pushd obj-static-debug
%makeinstall
popd
pushd obj-shared
%makeinstall
popd

# --- wxBase headers list begins here ---
cat <<EOF >wxbase-headers-list
%{_includedir}/wx-2.5/wx/afterstd.h
%{_includedir}/wx-2.5/wx/app.h
%{_includedir}/wx-2.5/wx/apptrait.h
%{_includedir}/wx-2.5/wx/arrimpl.cpp
%{_includedir}/wx-2.5/wx/arrstr.h
%{_includedir}/wx-2.5/wx/beforestd.h
%{_includedir}/wx-2.5/wx/buffer.h
%{_includedir}/wx-2.5/wx/build.h
%{_includedir}/wx-2.5/wx/chkconf.h
%{_includedir}/wx-2.5/wx/cmdline.h
%{_includedir}/wx-2.5/wx/confbase.h
%{_includedir}/wx-2.5/wx/config.h
%{_includedir}/wx-2.5/wx/containr.h
%{_includedir}/wx-2.5/wx/datetime.h
%{_includedir}/wx-2.5/wx/datetime.inl
%{_includedir}/wx-2.5/wx/datstrm.h
%{_includedir}/wx-2.5/wx/dde.h
%{_includedir}/wx-2.5/wx/debug.h
%{_includedir}/wx-2.5/wx/defs.h
%{_includedir}/wx-2.5/wx/dir.h
%{_includedir}/wx-2.5/wx/dlimpexp.h
%{_includedir}/wx-2.5/wx/dynarray.h
%{_includedir}/wx-2.5/wx/dynlib.h
%{_includedir}/wx-2.5/wx/dynload.h
%{_includedir}/wx-2.5/wx/encconv.h
%{_includedir}/wx-2.5/wx/event.h
%{_includedir}/wx-2.5/wx/except.h
%{_includedir}/wx-2.5/wx/features.h
%{_includedir}/wx-2.5/wx/ffile.h
%{_includedir}/wx-2.5/wx/file.h
%{_includedir}/wx-2.5/wx/fileconf.h
%{_includedir}/wx-2.5/wx/filefn.h
%{_includedir}/wx-2.5/wx/filename.h
%{_includedir}/wx-2.5/wx/filesys.h
%{_includedir}/wx-2.5/wx/fontenc.h
%{_includedir}/wx-2.5/wx/fontmap.h
%{_includedir}/wx-2.5/wx/fs_mem.h
%{_includedir}/wx-2.5/wx/fs_zip.h
%{_includedir}/wx-2.5/wx/hash.h
%{_includedir}/wx-2.5/wx/hashmap.h
%{_includedir}/wx-2.5/wx/hashset.h
%{_includedir}/wx-2.5/wx/iconloc.h
%{_includedir}/wx-2.5/wx/init.h
%{_includedir}/wx-2.5/wx/intl.h
%{_includedir}/wx-2.5/wx/iosfwrap.h
%{_includedir}/wx-2.5/wx/ioswrap.h
%{_includedir}/wx-2.5/wx/ipc.h
%{_includedir}/wx-2.5/wx/ipcbase.h
%{_includedir}/wx-2.5/wx/isql.h
%{_includedir}/wx-2.5/wx/isqlext.h
%{_includedir}/wx-2.5/wx/list.h
%{_includedir}/wx-2.5/wx/listimpl.cpp
%{_includedir}/wx-2.5/wx/log.h
%{_includedir}/wx-2.5/wx/longlong.h
%{_includedir}/wx-2.5/wx/math.h
%{_includedir}/wx-2.5/wx/memconf.h
%{_includedir}/wx-2.5/wx/memory.h
%{_includedir}/wx-2.5/wx/memtext.h
%{_includedir}/wx-2.5/wx/mimetype.h
%{_includedir}/wx-2.5/wx/module.h
%{_includedir}/wx-2.5/wx/msgout.h
%{_includedir}/wx-2.5/wx/mstream.h
%{_includedir}/wx-2.5/wx/object.h
%{_includedir}/wx-2.5/wx/platform.h
%{_includedir}/wx-2.5/wx/process.h
%{_includedir}/wx-2.5/wx/ptr_scpd.h
%{_includedir}/wx-2.5/wx/regex.h
%{_includedir}/wx-2.5/wx/scopeguard.h
%{_includedir}/wx-2.5/wx/snglinst.h
%{_includedir}/wx-2.5/wx/stack.h
%{_includedir}/wx-2.5/wx/stopwatch.h
%{_includedir}/wx-2.5/wx/strconv.h
%{_includedir}/wx-2.5/wx/stream.h
%{_includedir}/wx-2.5/wx/string.h
%{_includedir}/wx-2.5/wx/sysopt.h
%{_includedir}/wx-2.5/wx/textbuf.h
%{_includedir}/wx-2.5/wx/textfile.h
%{_includedir}/wx-2.5/wx/thread.h
%{_includedir}/wx-2.5/wx/thrimpl.cpp
%{_includedir}/wx-2.5/wx/timer.h
%{_includedir}/wx-2.5/wx/tokenzr.h
%{_includedir}/wx-2.5/wx/txtstrm.h
%{_includedir}/wx-2.5/wx/types.h
%{_includedir}/wx-2.5/wx/utils.h
%{_includedir}/wx-2.5/wx/variant.h
%{_includedir}/wx-2.5/wx/vector.h
%{_includedir}/wx-2.5/wx/version.h
%{_includedir}/wx-2.5/wx/volume.h
%{_includedir}/wx-2.5/wx/wfstream.h
%{_includedir}/wx-2.5/wx/wx.h
%{_includedir}/wx-2.5/wx/wxchar.h
%{_includedir}/wx-2.5/wx/wxprec.h
%{_includedir}/wx-2.5/wx/xti.h
%{_includedir}/wx-2.5/wx/xtistrm.h
%{_includedir}/wx-2.5/wx/zipstrm.h
%{_includedir}/wx-2.5/wx/zstream.h
%{_includedir}/wx-2.5/wx/fs_inet.h
%{_includedir}/wx-2.5/wx/gsocket.h
%{_includedir}/wx-2.5/wx/protocol/file.h
%{_includedir}/wx-2.5/wx/protocol/ftp.h
%{_includedir}/wx-2.5/wx/protocol/http.h
%{_includedir}/wx-2.5/wx/protocol/protocol.h
%{_includedir}/wx-2.5/wx/sckaddr.h
%{_includedir}/wx-2.5/wx/sckipc.h
%{_includedir}/wx-2.5/wx/sckstrm.h
%{_includedir}/wx-2.5/wx/socket.h
%{_includedir}/wx-2.5/wx/url.h
%{_includedir}/wx-2.5/wx/xml/xml.h
%{_includedir}/wx-2.5/wx/xtixml.h
%{_includedir}/wx-2.5/wx/db.h
%{_includedir}/wx-2.5/wx/dbkeyg.h
%{_includedir}/wx-2.5/wx/dbtable.h
EOF
# --- wxBase headers list ends here ---

# Move wxbase header out of the way
mkdir -p $RPM_BUILD_ROOT/tmp
cp -a $RPM_BUILD_ROOT%{_includedir}/* $RPM_BUILD_ROOT/tmp
for f in `cat wxbase-headers-list` ; do
  rm -f $RPM_BUILD_ROOT$f
done
# list of all core headers:
find $RPM_BUILD_ROOT/usr/include/wx-2.5 -type f | sed -e "s,$RPM_BUILD_ROOT,,g" >core-headers.files
# Now move headers back
cp -a $RPM_BUILD_ROOT/tmp/* $RPM_BUILD_ROOT%{_includedir}
rm -rf $RPM_BUILD_ROOT/tmp

# contrib stuff:
pushd obj-shared/contrib/src
%makeinstall
popd
pushd obj-shared/utils/wxrc
%makeinstall
popd
pushd obj-shared-unicode/contrib/src
%makeinstall
popd
pushd obj-static/contrib/src
%makeinstall
popd
pushd obj-static-debug/contrib/src
%makeinstall
popd
pushd obj-static-unicode/contrib/src
%makeinstall
popd
pushd obj-static-unicode-debug/contrib/src
%makeinstall
popd
#
# Fix broken absolute symlink into build-root
#
pushd $RPM_BUILD_ROOT/%{_bindir}
LDST=`find . -name wx-config -printf '%l\n' | sed -e "s,$RPM_BUILD_ROOT,../..,"`
ln -snf $LDST wx-config
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%post gl
/sbin/ldconfig

%postun gl
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc COPYING.LIB *.txt
%dir %{_datadir}/wx
%{_datadir}/wx/*
%{_libdir}/libwx_%{portname}*_core*.so.*
%{_libdir}/libwx_%{portname}*_html*.so.*
%{_libdir}/libwx_%{portname}*_adv*.so.*
%{_libdir}/libwx_%{portname}*_dbgrid*.so.*

%files devel -f core-headers.files
%defattr(-,root,root)
%{_libdir}/libwx_%{portname}*_core*.so
%{_libdir}/libwx_%{portname}*_html*.so
%{_libdir}/libwx_%{portname}*_adv*.so
%{_libdir}/libwx_%{portname}*_dbgrid*.so
%{_libdir}/libwx_%{portname}*_gl*.so
%dir %{_libdir}/wx
%{_libdir}/wx/*
%{_bindir}/*

%files gl
%defattr(-,root,root)
%{_libdir}/libwx_%{portname}*_gl*.so.*

%files static
%defattr (-,root,root)
%{_libdir}/libwx_gtk*.a

%files contrib
%defattr(-,root,root)
%{_libdir}/libwx_%{portname}*_animate*.so.*
%{_libdir}/libwx_%{portname}*_deprecated*.so.*
%{_libdir}/libwx_%{portname}*_fl*.so.*
%{_libdir}/libwx_%{portname}*_gizmos*.so.*
%{_libdir}/libwx_%{portname}*_mmedia*.so.*
%{_libdir}/libwx_%{portname}*_ogl*.so.*
%{_libdir}/libwx_%{portname}*_plot*.so.*
%{_libdir}/libwx_%{portname}*_stc*.so.*
%{_libdir}/libwx_%{portname}*_svg*.so.*
%{_libdir}/libwx_%{portname}*_xrc*.so.*

%files contrib-devel
%defattr(-,root,root)
%{_bindir}/wxrc
%dir %{_includedir}/wx-2.5/wx/animate
%{_includedir}/wx-2.5/wx/animate/*
%{_libdir}/libwx_%{portname}*_animate*.so

%dir %{_includedir}/wx-2.5/wx/deprecated
%{_includedir}/wx-2.5/wx/deprecated/*
%{_libdir}/libwx_%{portname}*_deprecated*.so

%dir %{_includedir}/wx-2.5/wx/fl
%{_includedir}/wx-2.5/wx/fl/*
%{_libdir}/libwx_%{portname}*_fl*.so

%dir %{_includedir}/wx-2.5/wx/gizmos
%{_includedir}/wx-2.5/wx/gizmos/*
%{_libdir}/libwx_%{portname}*_gizmos*.so

%dir %{_includedir}/wx-2.5/wx/mmedia
%{_includedir}/wx-2.5/wx/mmedia/*
%{_libdir}/libwx_%{portname}*_mmedia*.so

%dir %{_includedir}/wx-2.5/wx/ogl
%{_includedir}/wx-2.5/wx/ogl/*
%{_libdir}/libwx_%{portname}*_ogl*.so

%dir %{_includedir}/wx-2.5/wx/plot
%{_includedir}/wx-2.5/wx/plot/*
%{_libdir}/libwx_%{portname}*_plot*.so

%dir %{_includedir}/wx-2.5/wx/stc
%{_includedir}/wx-2.5/wx/stc/*
%{_libdir}/libwx_%{portname}*_stc*.so

%dir %{_includedir}/wx-2.5/wx/svg
%{_includedir}/wx-2.5/wx/svg/*
%{_libdir}/libwx_%{portname}*_svg*.so

%dir %{_includedir}/wx-2.5/wx/xrc
%{_includedir}/wx-2.5/wx/xrc/*
%{_libdir}/libwx_%{portname}*_xrc*.so

%files -n %{wxbasename}
%defattr(-,root,root)
%{_libdir}/libwx_base*.so.*
%{_datadir}/aclocal/*
%{_datadir}/locale/*/*/*

%files -n %{wxbasename}-static
%defattr(-,root,root)
%{_libdir}/libwx_base*.a
%{_libdir}/libwxodbc*.a
%{_libdir}/libwxregex*.a

%files -n %{wxbasename}-devel -f wxbase-headers-list
%defattr(-,root,root)
%{_libdir}/libwx_base*.so

%changelog
* Thu Oct 28 2004 Fritz Elfert <fritz.elfert@millenux.com>
- Fixed name of installed wx-config scripts
